<template>
    <div>
        <Base activeIndex="4">
        </Base>
        <div class="container">
            <el-row class="header">
                <el-col>
                    更改权限
                </el-col>
            </el-row>
            <el-row class="main">
                <el-row :gutter="100">
                    <el-col :span="1000" :push="1000">
                        <el-card class="box-card">
                            <!-- <div v-for="o in 4" :key="o" class="text item">{{ 'List item ' + o }}</div> -->
                            <div style="margin: 20px" />
                            <el-form :label-position="right" label-width="100px" :model="formLabelAlign"
                                style="max-width: 460px">
                                <el-form-item label="学号">
                                    <span>{{ ruleForm.uid }}</span>
                                </el-form-item>
                                <el-form-item label="姓名">
                                    <span>{{ ruleForm.name }}</span>
                                </el-form-item>
                                <el-form-item label="学院">
                                    <span>{{ academy }}</span>
                                </el-form-item>
                                <!-- <el-form-item label="专业">
                                    <span>{{ major }}</span>
                                </el-form-item> -->
                                <el-form-item label="当前权限">
                                    <span>{{ permission }}</span>
                                </el-form-item>
                                <el-form-item label="活动">
                                    <span v-for="item in ruleForm.activities_list" :key="item.id">{{ item.topic
                                    }}</span>
                                </el-form-item>

                            </el-form>
                        </el-card>
                    </el-col>
                    <el-col :span="1000" :push="1000">
                        <el-card class="box-card">
                            <!-- <div v-for="o in 4" :key="o" class="text item">{{ 'List item ' + o }}</div> -->

                            <el-select v-model="selectingPermission" class="m-2" placeholder="选择权限" size="large"
                                @change="handleSelectChange">
                                <el-option v-for="permission in permissions" :key="permission.value"
                                    :label="permission.label" :value="permission.value" />
                            </el-select>
                            <!-- <div>{{selectingPermission}}</div> -->
                            <br />
                            <br />
                            <br />
                            <br />
                            <br />
                            <el-select v-if="ruleForm.authority === '2' || ruleForm.authority === '3'"
                                v-model="selectingActivity" class="m-2" placeholder="选择活动范围" size="large">
                                <el-option v-for="item in ruleForm.activities" :key="item.value" :label="item.topic"
                                    :value="item.value" />
                            </el-select>
                            <!-- <div>{{selectingActivity}}</div> -->
                            <br />
                            <br />
                            <br />
                            <br />
                            <br />
                            <br />
                            <br />
                            <el-button type="danger" round size="large" @click="changeAuthority">修改权限</el-button>
                            <br />
                            <br />
                            <br />
                            <br />
                            <br />
                            <el-button @click="addAuthorityVisible = true" type="success" size="large">增加权限
                            </el-button>
                            <el-dialog v-model="addAuthorityVisible">
                                <el-form>
                                    <el-form-item label="增加的活动权限">
                                        <el-select v-model="selectingActivity" class="m-2" placeholder="选择活动范围"
                                            size="large">
                                            <el-option v-for="item in ruleForm.activities" :key="item.value"
                                                :label="item.topic" :value="item.value" />
                                        </el-select>
                                    </el-form-item>
                                </el-form>
                                <template #footer>
                                    <span class="dialog-footer">
                                        <el-button @click="addAuthorityVisible = false">Cancel</el-button>
                                        <el-button type="primary" @click="addAuthority">Confirm
                                        </el-button>
                                    </span>
                                </template>
                            </el-dialog>
                            <el-button @click="deleteAuthorityVisible = true" type="danger" size="large">删除权限
                            </el-button>
                            <el-dialog v-model="deleteAuthorityVisible">
                                <el-form>
                                    <el-form-item label="删除的活动权限">
                                        <el-select v-model="selectingActivity" class="m-2" placeholder="选择活动范围"
                                            size="large">
                                            <el-option v-for="item in ruleForm.activities" :key="item.value"
                                                :label="item.topic" :value="item.value" />
                                        </el-select>
                                    </el-form-item>
                                </el-form>
                                <template #footer>
                                    <span class="dialog-footer">
                                        <el-button @click="deleteAuthorityVisible = false">Cancel</el-button>
                                        <el-button type="primary" @click="deleteAuthority">Confirm
                                        </el-button>
                                    </span>
                                </template>
                            </el-dialog>
                        </el-card>
                    </el-col>

                </el-row>
            </el-row>
        </div>
    </div>
</template>

<script lang="ts">
import axios from "axios";
import Base from "./Base.vue";
import { onMounted, reactive, ref } from 'vue'
import SelectPermission from './SelectPermission.vue';
function getQueryVariable(variable) {
    var query = window.location.search.substring(1);
    var vars = query.split("&");
    for (var i = 0; i < vars.length; i++) {
        var pair = vars[i].split("=");
        if (pair[0] == variable) { return decodeURI(pair[1]); }
    }
    return (false);
}

const labelPosition = ref('right')

const formLabelAlign = reactive({
    name: '',
    region: '',
    type: '',
})
interface PermissionList {
    date: string
    name: string
    address: string
}
export default {
    name: "SelectPermission",
    data() {
        return {
            academy: getQueryVariable("academy"),
            major: getQueryVariable("major"),
            permission: getQueryVariable("permission"),
            selectingPermission: '',
            selectingActivity: '',
            addAuthorityVisible: false,
            deleteAuthorityVisible: false,
        }
    },

    components: {
        Base,
        SelectPermission
    }
}

</script>

<script lang="ts" setup>

import { reactive, ref, onMounted } from 'vue'
import type { FormInstance, FormRules } from 'element-plus'
import { useRoute } from 'vue-router'
import global from "./Common.vue"

const route = useRoute()
const formSize = ref('default')
const ruleFormRef = ref<FormInstance>()
const ruleForm = reactive({
    authority: "",
    uid: "",
    activities: [],
    name: '',
    activities_list: [],
    addtemp_aid: "",
    deltemp_aid: ""
})





const permissions = [
    {
        label: '管理员',
        value: '0'
    },
    {
        label: '辅导员',
        value: '1'
    }, {
        label: '临时辅导员',
        value: '2'
    }, {
        label: '普通用户',
        value: '3'
    },
]

const getActivityTable = async (formEl: FormInstance | undefined) => {
    let token = localStorage.getItem("token");
    axios({
        method: "POST",
        url: "",
        data: {

        },
        headers: { Authorization: `Bearer: ${token}` },
    }).then((res) => {
        console.log(res);
    });
}





let activities = [
    {
        label: '活动1',
        value: '0'
    }, {
        label: '活动2',
        value: '1'
    }, {
        label: '活动3',
        value: '2'
    },
]

const handleSelectChange = (e) => {
    ruleForm.authority = e
}

const addAuthority = async () => {
    console.log("收到增加权限请求")
    let token = localStorage.getItem('token');
    axios({
        method: "POST",
        url: "http://" + global.ip + "/api/authority/addtemp",
        data: {
            aid: ruleForm.addtemp_aid,
            uid: ruleForm.uid,
        },
         headers: { 'Authorization': `Bearer: ${token}` }
    }).then((res) => {
        console.log(res.data.aid, res)
        window.location.replace("http://" + global.ip_front + "/permission_list")
    })
}

const deleteAuthority = async () => {
    console.log("收到删除权限请求")
    let token = localStorage.getItem('token');
    axios({
        method: "POST",
        url: "http://" + global.ip + "/api/authority/deltemp",
        data: {
            aid: ruleForm.deltemp_aid,
            uid: ruleForm.uid,
        },
         headers: { 'Authorization': `Bearer: ${token}` }
    }).then((res) => {
        console.log(res.data.aid, res)
        window.location.replace("http://" + global.ip_front + "/permission_list")
    })
}


const changeAuthority = async () => {
    let token = localStorage.getItem('token');
    console.log(ruleForm.uid);

    axios({
        method: "POST",
        url: "http://" + global.ip + "/api/authority/change",
        data: {
            uid: ruleForm.uid,
            authority: ruleForm.authority,
        },
        headers: { 'Authorization': `Bearer: ${token}` }
    }).then((res) => {
        console.log(res);

        ruleForm.activities = res.data.activities_list
        alert("已经成功修改!")
        window.location.replace("http://" + global.ip_front + "/permission_list")

    })
}



onMounted(() => {
    console.log("testtest")
    console.log(route.query)
    ruleForm.uid = route.query.id
    ruleForm.name = route.query.name
    // axios  post 请求 http://xx.com/api/authority/activities_with_authorities

    let token = localStorage.getItem('token');
    axios({
        method: "POST",
        url: "http://" + global.ip + "/api/authority/activities_available",
        data: {
            uid: ruleForm.uid,
        },
        headers: { 'Authorization': `Bearer: ${token}` }
    }).then((res) => {
        console.log(res);
        ruleForm.activities = res.data.activities
    })

    axios({
        method: "POST",
        url: "http://" + global.ip + "/api/authority/activities_with_authorities",
        data: {
            uid: ruleForm.uid,
        },
        headers: { 'Authorization': `Bearer: ${token}` }
    }).then((res) => {
        console.log(res);
        ruleForm.activities_list = res.data.activities_list;
        // window.location.replace("http://" + global.ip_front + "/permission_list")
    })
})

</script>

<style scoped>
.container {
    position: absolute;
    width: 100%;
    height: 100%;
    background-color: rgb(238, 241, 246);
}

.box-card {
    position: relative;
    width: 400px;
    height: 500px;
    top: 70px;
    left: 200px;
    padding: 50px;
}


.header {
    position: relative;
    font-size: 50px;
    top: 30px;
}

.el-row {
    margin-bottom: 20px;
}

.el-row:last-child {
    margin-bottom: 0;
}

.el-col {
    border-radius: 4px;
}

.grid-content {
    border-radius: 4px;
    min-height: 36px;
    color: blue;
}
</style>